"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CppHeaderCreator = void 0;
class CppHeaderCreator {
    static create(className, extendingClassName, headerDefine, protectedMembers, publicMembers, includes) {
        let cppHeader = `
/* ${className}.h */

#ifndef ${headerDefine}
#define ${headerDefine}

${includes}


class ${className} : public ${extendingClassName} 
{
  GDCLASS(${className}, ${extendingClassName});

protected:
  static void _bind_methods();
  ${protectedMembers}

public:

  ${publicMembers}

  ${className}();

  ~${className}();
};


#endif // ${headerDefine}
`;
        return cppHeader;
    }
}
exports.CppHeaderCreator = CppHeaderCreator;
//# sourceMappingURL=CppHeaderCreator.js.map