"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GodotTypes = void 0;
class GodotTypes {
    static stringToVariantType(stringType) {
        if (/^TypedArray\<.+\>$/.test(stringType)) {
            return "ARRAY";
        }
        switch (stringType) {
            case "bool": return "BOOL";
            case "int": return "INT";
            case "float": return "FLOAT";
            case "String": return "STRING";
            // Math
            case "Vector2": return "VECTOR2";
            case "Vector2i": return "VECTOR2I";
            case "Rect2": return "RECT2";
            case "Rect2i": return "RECT2I";
            case "Transform2D": return "TRANSFORM2D";
            case "Vector3": return "VECTOR3";
            case "Vector3i": return "VECTOR3I";
            case "Vector4": return "VECTOR4";
            case "Vector4i": return "VECTOR4I";
            case "Plane": return "PLANE";
            case "AABB": return "AABB";
            case "Quaternion": return "QUATERNION";
            case "Basis": return "BASIS";
            case "Transform3D": return "TRANSFORM3D";
            case "Projection": return "PROJECTION";
            // Miscellaneous
            case "Color": return "COLOR";
            case "RID": return "RID";
            case "Object": return "OBJECT";
            case "Callable": return "CALLABLE";
            case "Signal": return "SIGNAL";
            case "StringName": return "STRING_NAME";
            case "NodePath": return "NODE_PATH";
            case "Dictionary": return "DICTIONARY";
            case "Array": return "ARRAY";
            // Arrays
            case "PackedByteArray": return "PACKED_BYTE_ARRAY";
            case "PackedInt32Array": return "PACKED_INT32_ARRAY";
            case "PackedInt64Array": return "PACKED_INT64_ARRAY";
            case "PackedFloat32Array": return "PACKED_FLOAT32_ARRAY";
            case "PackedFloat64Array": return "PACKED_FLOAT64_ARRAY";
            case "PackedStringArray": return "PACKED_STRING_ARRAY";
            case "PackedVector2Array": return "PACKED_VECTOR2_ARRAY";
            case "PackedVector3Array": return "PACKED_VECTOR3_ARRAY";
            case "PackedColorArray": return "PACKED_COLOR_ARRAY";
        }
        console.error("Type could not be mapped: ", stringType);
        return "OBJECT";
    }
}
exports.GodotTypes = GodotTypes;
//# sourceMappingURL=GodotTypes.js.map