"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Header = void 0;
class Header {
    static create(className, extendingClassName, headerDefine, protectedMembers, publicMembers, includes, forwardDeclarations) {
        let cppHeader = `
/* ${className}.h */

#ifndef ${headerDefine}
#define ${headerDefine}

${includes}

${forwardDeclarations}


class ${className} : public ${extendingClassName} 
{
  GDCLASS( ${className}, ${extendingClassName} );

protected:
  static void _bind_methods();
  ${protectedMembers}

public:

  ${publicMembers}

  //  Constructor
  ${className}();

  //  Destructor
  ~${className}();
};


#endif // ${headerDefine}
`;
        return cppHeader;
    }
}
exports.Header = Header;
//# sourceMappingURL=Header.js.map