"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeRegistration = void 0;
const Files_1 = require("../library/Files");
const CppCreator_1 = require("./CppCreator");
class TypeRegistration {
    static createRegistrations() {
        return __awaiter(this, void 0, void 0, function* () {
            let registrationImplementation = yield Files_1.Files.loadUTF8(CppCreator_1.CppCreator.registerTypesPath);
            let allFiles = yield Files_1.Files.getFiles(CppCreator_1.CppCreator.outputPath);
            let filter = (file) => {
                if (TypeRegistration.exceptions.indexOf(file) !== -1) {
                    return false;
                }
                return file.endsWith(".h") && file != "register_types.h";
            };
            let headers = allFiles.filter(file => filter(file));
            let includeStatements = headers.map(h => `#include "./${h}"`);
            let includes = includeStatements.join("\n");
            registrationImplementation =
                registrationImplementation.replace(TypeRegistration.includesRegex, includes);
            let classNames = headers.map(h => h.replace(/\.h$/, ""));
            let registrators = classNames.map(cn => `ClassDB::register_class<${cn}>();`);
            let registrations = registrators.join("\n  ");
            registrationImplementation =
                registrationImplementation.replace(TypeRegistration.classDBRegistrationsRegex, registrations);
            yield Files_1.Files.saveUTF8(CppCreator_1.CppCreator.registerTypesPathOutput, registrationImplementation);
        });
    }
}
exports.TypeRegistration = TypeRegistration;
TypeRegistration.includesRegex = /\/\*INCLUDES\*\//;
TypeRegistration.classDBRegistrationsRegex = /\/\*CLASS-DB-REGISTRATIONS\*\//;
TypeRegistration.exceptions = [
    "RJGodotHeaders.h"
];
//# sourceMappingURL=TypeRegistration.js.map