"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionFactory = void 0;
const BaseFactory_1 = require("./BaseFactory");
class ActionFactory extends BaseFactory_1.BaseFactory {
    constructor() { super(ActionFactory.regex); }
    create(accessModifier, nameDefinition, memberData, members) {
        let name = ActionFactory.regex.exec(nameDefinition)[1];
        let upperCaseName = name[0].toUpperCase() + name.substring(1);
        let actionName = `on${upperCaseName}`;
        let signal = `signal ${name}()`;
        members.push(this.createMember(accessModifier, signal, {}));
        members.push(this.createMember(accessModifier, actionName, "Node<RJAction>"));
    }
}
exports.ActionFactory = ActionFactory;
ActionFactory.regex = /^\s*action\s+(\w+)\s*$/;
//# sourceMappingURL=ActionFactory.js.map