"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemberFactory = void 0;
const ActionFactory_1 = require("./ActionFactory");
const PropertyFactory_1 = require("./PropertyFactory");
const BaseFactory_1 = require("./BaseFactory");
class MemberFactory {
    static grabMembers(membersData, accessModifier) {
        let members = [];
        if (!membersData) {
            return members;
        }
        for (let it in membersData) {
            if (!membersData.hasOwnProperty(it)) {
                continue;
            }
            let nameDefinition = it;
            let memberData = membersData[it];
            let factory = this.factories.find(f => f.handles(nameDefinition));
            if (factory) {
                factory.create(accessModifier, nameDefinition, memberData, members);
            }
            else {
                members.push(BaseFactory_1.BaseFactory.createMemberFrom(accessModifier, nameDefinition, memberData));
            }
            /*
            if ( MemberFactory.actionRegex.test( nameDefinition ) )
            {
              let name = MemberFactory.actionRegex.exec( nameDefinition )[ 1 ];
              let upperCaseName = name[ 0 ].toUpperCase() + name.substring( 1 );
              let actionName = `on${upperCaseName}`;
      
              let signal = `signal ${name}()`;
      
              members.push( MemberFactory.create( accessModifier, signal, {} ) );
              members.push( MemberFactory.create( accessModifier, actionName, "Node<RJAction>" ) );
            }
            else if ( MemberFactory.propertyRegex.test( nameDefinition ) )
            {
              let result = MemberFactory.propertyRegex.exec( nameDefinition );
      
              let signalName = result[ 1 ];
              let fieldName  = result[ 2 ];
      
              signalName = signalName || `${fieldName}Changed`;
      
              let upperCaseName = signalName[ 0 ].toUpperCase() + signalName.substring( 1 );
              let actionName = `on${upperCaseName}`;
      
              let signal = `signal ${signalName}()`;
      
              if ( ! result[ 1 ] )
              {
                members.push( MemberFactory.create( accessModifier, signal, {} ) );
                members.push( MemberFactory.create( accessModifier, actionName, "Node<RJAction>" ) );
              }
      
              let field = MemberFactory.create( accessModifier, fieldName, memberData ) as Field;
      
              field.isProperty = true;
              field.propertySignalName = signalName;
              field.propertyActionName = actionName;
      
              members.push( field );
            }
            else
            {
              let classMember = MemberFactory.create(  accessModifier, nameDefinition, memberData );
              members.push( classMember );
            }
      
            */
        }
        return members;
    }
}
exports.MemberFactory = MemberFactory;
MemberFactory.actionRegex = /^\s*action\s+(\w+)\s*$/;
MemberFactory.propertyRegex = /^\s*property(?:\s*\@\s*(\w+))?\s+(\w+)\s*$/;
MemberFactory.factories = [
    new ActionFactory_1.ActionFactory(),
    new PropertyFactory_1.PropertyFactory()
];
//# sourceMappingURL=MemberFactory.js.map